/**
 * Flowtype definitions for type.ts
 * Generated by Flowgen from a Typescript Definition
 * Flowgen v1.10.0
 */

declare interface FlvJs$MediaSegment {
  duration: number;
  filesize?: number;
  url: string;
}

declare interface FlvJs$MediaDataSource {
  type: string;
  isLive?: boolean;
  cors?: boolean;
  withCredentials?: boolean;
  hasAudio?: boolean;
  hasVideo?: boolean;
  duration?: number;
  filesize?: number;
  url?: string;
  segments?: FlvJs$MediaSegment[];
}

declare interface FlvJs$Config {
  /**
   * @desc Enable separated thread for transmuxing (unstable for now)
   * @defaultvalue false
   */
  enableWorker?: boolean;

  /**
   * @desc Enable IO stash buffer. Set to false if you need realtime (minimal latency) for live stream
   *    playback, but may stalled if there's network jittering.
   * @defaultvalue true
   */
  enableStashBuffer?: boolean;

  /**
   * @desc Indicates IO stash buffer initial size. Default is `384KB`. Indicate a suitable size can
   *    improve video load/seek time.
   */
  stashInitialSize?: number;

  /**
   * @desc Same to `isLive` in **MediaDataSource**, ignored if has been set in MediaDataSource structure.
   * @defaultvalue false
   */
  isLive?: boolean;

  /**
   * @desc Abort the http connection if there's enough data for playback.
   * @defaultvalue true
   */
  lazyLoad?: boolean;

  /**
   * @desc Indicates how many seconds of data to be kept for `lazyLoad`.
   * @defaultvalue 3 * 60
   */
  lazyLoadMaxDuration?: number;

  /**
   * @desc Indicates the `lazyLoad` recover time boundary in seconds.
   * @defaultvalue 30
   */
  lazyLoadRecoverDuration?: number;

  /**
   * @desc Do load after MediaSource `sourceopen` event triggered. On Chrome, tabs which
   *    be opened in background may not trigger `sourceopen` event until switched to that tab.
   * @defaultvalue true
   */
  deferLoadAfterSourceOpen?: boolean;

  /**
   * @desc Do auto cleanup for SourceBuffer
   * @defaultvalue false (from docs)
   */
  autoCleanupSourceBuffer?: boolean;

  /**
   * @desc When backward buffer duration exceeded this value (in seconds), do auto cleanup for SourceBuffer
   * @defaultvalue 3 * 60
   */
  autoCleanupMaxBackwardDuration?: number;

  /**
   * @desc Indicates the duration in seconds to reserve for backward buffer when doing auto cleanup.
   * @defaultvalue 2 * 60
   */
  autoCleanupMinBackwardDuration?: number;

  /**
   * @defaultvalue 600
   */
  statisticsInfoReportInterval?: number;

  /**
   * @desc Fill silent audio frames to avoid a/v unsync when detect large audio timestamp gap.
   * @defaultvalue true
   */
  fixAudioTimestampGap?: boolean;

  /**
   * @desc Accurate seek to any frame, not limited to video IDR frame, but may a bit slower.
   *    Available on Chrome > 50, FireFox and Safari.
   * @defaultvalue false
   */
  accurateSeek?: boolean;

  /**
   * @desc 'range' use range request to seek, or 'param' add params into url to indicate request range.
   * @defaultvalue 'range'
   */
  seekType?: "range" | "param" | "custom";

  /**
   * @desc Indicates seek start parameter name for seekType = 'param'
   * @defaultvalue 'bstart'
   */
  seekParamStart?: string;

  /**
   * @desc Indicates seek end parameter name for seekType = 'param'
   * @defaultvalue 'bend'
   */
  seekParamEnd?: string;

  /**
   * @desc Send Range: bytes=0- for first time load if use Range seek
   * @defaultvalue false
   */
  rangeLoadZeroStart?: boolean;

  /**
   * @desc Indicates a custom seek handler
   * @desc Should implement `SeekHandler` interface
   */
  customSeekHandler?: FlvJs$CustomSeekHandlerConstructor;

  /**
   * @desc Reuse 301/302 redirected url for subsequence request like seek, reconnect, etc.
   * @defaultvalue false
   */
  reuseRedirectedURL?: boolean;

  /**
   * @desc Indicates the Referrer Policy when using FetchStreamLoader
   * @defaultvalue 'no-referrer-when-downgrade' (from docs)
   */
  referrerPolicy?: ReferrerPolicy;

  /**
   * @desc Should implement `BaseLoader` interface
   */
  customLoader?: FlvJs$CustomLoaderConstructor;
}

declare interface FlvJs$CustomSeekHandlerConstructor {
  new(): FlvJs$SeekHandler;
}

declare interface FlvJs$SeekHandler {
  getConfig(sourceURL: string, range: FlvJs$Range): FlvJs$SeekConfig;
  removeURLParameters(url: string): string;
}

declare interface FlvJs$SeekConfig {
  url: string;
  headers: Headers | { [key: string]: any };
}

declare interface FlvJs$BaseLoaderConstructor {
  new(typeName: string): FlvJs$BaseLoader;
}

declare interface FlvJs$BaseLoader {
  _status: number;
  _needStash: boolean;
  destroy(): void;
  isWorking(): boolean;
  +type: string;
  +status: number;
  +needStashBuffer: boolean;
  onContentLengthKnown: (contentLength: number) => void;
  onURLRedirect: (redirectedURL: string) => void;
  onDataArrival: (
    chunk: ArrayBuffer,
    byteStart: number,
    receivedLength?: number
  ) => void;
  onError: (
    errorType: FlvJs$LoaderErrors,
    errorInfo: FlvJs$LoaderErrorMessage
  ) => void;
  onComplete: (rangeFrom: number, rangeTo: number) => void;
  open(dataSource: FlvJs$MediaSegment, range: FlvJs$Range): void;
  abort(): void;
}

declare interface FlvJs$CustomLoaderConstructor {
  new(seekHandler: FlvJs$SeekHandler, config: FlvJs$Config): FlvJs$BaseLoader;
}

declare interface FlvJs$Range {
  from: number;
  to: number;
}

declare interface FlvJs$LoaderStatus {
  +kIdle: 0;
  +kConnecting: 1;
  +kBuffering: 2;
  +kError: 3;
  +kComplete: 4;
}

declare interface FlvJs$LoaderErrors {
  +OK: "OK";
  +EXCEPTION: "Exception";
  +HTTP_STATUS_CODE_INVALID: "HttpStatusCodeInvalid";
  +CONNECTING_TIMEOUT: "ConnectingTimeout";
  +EARLY_EOF: "EarlyEof";
  +UNRECOVERABLE_EARLY_EOF: "UnrecoverableEarlyEof";
}

declare interface FlvJs$LoaderErrorMessage {
  code: number;
  msg: string;
}

declare interface FlvJs$FeatureList {
  mseFlvPlayback: boolean;
  mseLiveFlvPlayback: boolean;
  networkStreamIO: boolean;
  networkLoaderName: string;
  nativeMP4H264Playback: boolean;
  nativeWebmVP8Playback: boolean;
  nativeWebmVP9Playback: boolean;
}

declare interface FlvJs$PlayerConstructor {
  new(
    mediaDataSource: FlvJs$MediaDataSource,
    config?: FlvJs$Config
  ): FlvJs$Player;
}

declare interface FlvJs$Player {
  destroy(): void;
  on(event: string, listener: (...args: any[]) => void): void;
  off(event: string, listener: (...args: any[]) => void): void;
  attachMediaElement(mediaElement: HTMLMediaElement): void;
  detachMediaElement(): void;
  load(): void;
  unload(): void;
  play(): Promise<void> | void;
  pause(): void;
  type: string;
  buffered: TimeRanges;
  duration: number;
  volume: number;
  muted: boolean;
  currentTime: number;

  /**
   * @deprecated FlvPlayer/NativePlayer have its own `mediaInfo` field.
   * @desc Keep it for backwards compatibility
   * @since 1.4
   */
  mediaInfo: FlvJs$NativePlayerMediaInfo | FlvJs$FlvPlayerMediaInfo;

  /**
   * @deprecated FlvPlayer/NativePlayer have its own `statisticsInfo` field.
   * @desc Keep it for backwards compatibility
   * @since 1.4
   */
  statisticsInfo:
    | FlvJs$NativePlayerStatisticsInfo
    | FlvJs$FlvPlayerStatisticsInfo;
}

declare interface FlvJs$NativePlayerStatisticsInfo {
  playerType: "NativePlayer";
  url: string;
  decodedFrames?: number;
  droppedFrames?: number;
}

declare interface FlvJs$FlvPlayerReportStatisticsInfo {
  url: string;
  hasRedirect: boolean;
  redirectedURL?: string;
  speed: number;
  loaderType: string;
  currentSegmentIndex: number;
  totalSegmentCount: number;
}

declare type FlvJs$FlvPlayerStatisticsInfo = {
  playerType: "FlvPlayer",
  decodedFrames?: number,
  droppedFrames?: number,
  ...
} & $Rest<FlvJs$FlvPlayerReportStatisticsInfo, { ... }>;

declare interface FlvJs$NativePlayerMediaInfo {
  mimeType: string;
  duration?: number;
  width?: number;
  height?: number;
}

declare type FlvJs$FlvPlayerMediaInfo = {
  audioCodec?: string,
  videoCodec?: string,
  audioDataRate?: number,
  videoDataRate?: number,
  hasAudio?: boolean,
  hasVideo?: boolean,
  chromaFormat?: string,
  fps?: number,
  [k: string]: any,
  ...
} & FlvJs$NativePlayerMediaInfo;

declare type FlvJs$FlvPlayer = {
  mediaInfo: FlvJs$FlvPlayerMediaInfo,
  statisticsInfo: FlvJs$FlvPlayerStatisticsInfo,
  ...
} & FlvJs$Player;

declare type FlvJs$NativePlayer = {
  mediaInfo: FlvJs$NativePlayerMediaInfo,
  statisticsInfo: FlvJs$NativePlayerStatisticsInfo,
  ...
} & FlvJs$Player;

declare interface FlvJs$LoggingControlConfig {
  forceGlobalTag: boolean;
  globalTag: string;
  enableAll: boolean;
  enableDebug: boolean;
  enableVerbose: boolean;
  enableInfo: boolean;
  enableWarn: boolean;
  enableError: boolean;
}

declare type FlvJs$LoggingControl = {
  getConfig(): FlvJs$LoggingControlConfig,
  applyConfig(config: $Rest<FlvJs$LoggingControlConfig, { ... }>): void,
  addLogListener(listener: (...args: any[]) => void): void,
  removeLogListener(listener: (...args: any[]) => void): void,
  ...
} & FlvJs$LoggingControlConfig;

declare interface FlvJs$Events {
  ERROR: string;
  LOADING_COMPLETE: string;
  RECOVERED_EARLY_EOF: string;
  MEDIA_INFO: string;
  METADATA_ARRIVED: string;
  STATISTICS_INFO: string;
}

declare interface FlvJs$ErrorTypes {
  NETWORK_ERROR: string;
  MEDIA_ERROR: string;
  OTHER_ERROR: string;
}

declare interface FlvJs$ErrorDetails {
  NETWORK_EXCEPTION: string;
  NETWORK_STATUS_CODE_INVALID: string;
  NETWORK_TIMEOUT: string;
  NETWORK_UNRECOVERABLE_EARLY_EOF: string;
  MEDIA_MSE_ERROR: string;
  MEDIA_FORMAT_ERROR: string;
  MEDIA_FORMAT_UNSUPPORTED: string;
  MEDIA_CODEC_UNSUPPORTED: string;
}
declare var FlvJs: {
  createPlayer(
    mediaDataSource: FlvJs$MediaDataSource,
    config?: FlvJs$Config
  ): FlvJs$Player,
  isSupported(): boolean,
  getFeatureList(): FlvJs$FeatureList,

  /**
   * @deprecated Use `FlvJs.BaseLoaderConstructor` instead.
   *  Because it's not available on `flvjs` variable.
   * @desc implement interface `BaseLoader`
   * @since 1.4
   */
  BaseLoader: FlvJs$BaseLoaderConstructor,

  /**
   * @deprecated Use `FlvJs.BaseLoaderConstructor` instead.
   *  Because it's not available on `flvjs` variable.
   * @since 1.4
   */
  LoaderStatus: FlvJs$LoaderStatus,

  /**
   * @deprecated Use `FlvJs.BaseLoaderConstructor` instead.
   *  Because it's not available on `flvjs` variable.
   * @since 1.4
   */
  LoaderErrors: FlvJs$LoaderErrors,
  +version: string,
  +Events: $ReadOnly<FlvJs$Events>,
  +ErrorTypes: $ReadOnly<FlvJs$ErrorTypes>,
  +ErrorDetails: $ReadOnly<FlvJs$ErrorDetails>,
  +FlvPlayer: FlvJs$PlayerConstructor,
  +NativePlayer: FlvJs$PlayerConstructor,
  +LoggingControl: FlvJs$LoggingControl,
  ...
};
declare export default typeof FlvJs;
